<?php

	/*
		MarketPress Idealcheckoutmaestro Gateway Plugin
		Author: iDEAL Checkout - http://www.ideal-checkout.nl
	*/

	// Load gateway setings
	$sRootPath = dirname(__FILE__);

	while((strlen($sRootPath) > 3) && !is_dir($sRootPath . '/idealcheckout'))
	{
		$sRootPath = dirname($sRootPath);
	}

	if(!is_dir($sRootPath . '/idealcheckout'))
	{
		die('Cannot find /idealcheckout/ folder.<br>File: ' . __FILE__ . '<br>Line: ' . __LINE__);
	}

	require_once($sRootPath . '/idealcheckout/includes/library.php');



	class MP_Gateway_Idealcheckoutmaestro extends MP_Gateway_API
	{
		var $plugin_name = 'idealcheckoutmaestro';
		var $admin_name = '';
		var $public_name = '';
		var $force_ssl = false;
		var $ipn_url;
		var $skip_form = true;

		function on_creation() 
		{
			global $mp;

			$this->admin_name = 'iDEAL Checkout - Maestro';
			$this->public_name = 'Maestro';
		}

		function payment_form($aCart, $aShippingInfo)
		{
			global $mp;

			if(isset($_GET['payment_method']) && ($_GET['payment_method'] == 'maestro') && isset($_GET['payment_status']) && ($_GET['payment_status'] == 'cancelled'))
			{
				echo '<div class="mp_checkout_error">Uw betaling is geannuleerd.</div>';
			}
		}
	  
		function process_payment_form($aCart, $aShippingInfo)
		{
			global $mp;

			return 'process_payment_form';
		}

		function process_payment($aCart, $aBillingInfo, $aShippingInfo)
		{
			global $mp, $wpdb;

			$aItems = array();
			$fOrderTotal = 0.00;

			
			// Load order object
			$oOrder = new MP_Order();
			$fOrderTotal = $aCart->total(false);
			
			$aDatabaseSettings = idealcheckout_getDatabaseSettings();

			$sStoreCode = idealcheckout_getStoreCode();
			$sGatewayCode = 'maestro';
			$sLanguageCode = 'nl'; // nl, de, en
			$sCountryCode = '';
			$sCurrencyCode = 'EUR';

			$sOrderId = $oOrder->get_id();
			$sOrderCode = idealcheckout_getRandomCode(32);
			$aOrderParams = array();
			$sTransactionId = idealcheckout_getRandomCode(32);
			$sTransactionCode = idealcheckout_getRandomCode(32);
			$fTransactionAmount = round($fOrderTotal, 2);
			$sTransactionDescription = idealcheckout_getTranslation($sLanguageCode, 'idealcheckout', 'Webshop order #{0}', array($sOrderId));

			$sReturnUrl = $this->return_url;
			$sReturnUrl .= ((strpos($sReturnUrl, '?')) ? '&' : '?') . 'order_id=' . $sOrderId . '&order_code=' . $sOrderCode;

			$sTransactionPaymentUrl = $sReturnUrl;
			$sTransactionSuccessUrl = $sReturnUrl;
			$sTransactionPendingUrl = $sReturnUrl;
			$sTransactionFailureUrl = $sReturnUrl;


			$aPaymentInfo = array();
			$aPaymentInfo['gateway_public_name'] = $this->public_name;
			$aPaymentInfo['gateway_private_name'] = $this->admin_name;
			$aPaymentInfo['status'][time()] = 'OPEN';
			$aPaymentInfo['total'] = $fOrderTotal;
			$aPaymentInfo['currency'] = 'EUR';
			$aPaymentInfo['transaction_id'] = $sOrderId;  
			$aPaymentInfo['method'] = 'idealcheckoutmaestro';

		
			// Insert into #_transactions
			$sql = "INSERT INTO `" . $aDatabaseSettings['table'] . "` SET 
`id` = NULL, 
`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "', 
`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "', 
`order_params` = '" . idealcheckout_escapeSql(serialize($aOrderParams)) . "', 
`store_code` = " . (empty($sStoreCode) ? "NULL" : "'" . idealcheckout_escapeSql($sStoreCode) . "'") . ", 
`gateway_code` = '" . idealcheckout_escapeSql($sGatewayCode) . "', 
`language_code` = " . (empty($sLanguageCode) ? "NULL" : "'" . idealcheckout_escapeSql($sLanguageCode) . "'") . ", 
`country_code` = " . (empty($sCountryCode) ? "NULL" : "'" . idealcheckout_escapeSql($sCountryCode) . "'") . ", 
`currency_code` = '" . idealcheckout_escapeSql($sCurrencyCode) . "', 
`transaction_id` = '" . idealcheckout_escapeSql($sTransactionId) . "', 
`transaction_code` = '" . idealcheckout_escapeSql($sTransactionCode) . "', 
`transaction_params` = NULL, 
`transaction_date` = '" . idealcheckout_escapeSql(time()) . "', 
`transaction_amount` = '" . idealcheckout_escapeSql($fTransactionAmount) . "', 
`transaction_description` = '" . idealcheckout_escapeSql($sTransactionDescription) . "', 
`transaction_status` = NULL, 
`transaction_url` = NULL, 
`transaction_payment_url` = '" . idealcheckout_escapeSql($sTransactionPaymentUrl) . "', 
`transaction_success_url` = '" . idealcheckout_escapeSql($sTransactionSuccessUrl) . "', 
`transaction_pending_url` = '" . idealcheckout_escapeSql($sTransactionPendingUrl) . "', 
`transaction_failure_url` = '" . idealcheckout_escapeSql($sTransactionFailureUrl) . "', 
`transaction_log` = NULL;";


			idealcheckout_database_query($sql);

			
			
			$oOrder->save(array(
				'cart'			 => $aCart,
				'payment_info'	 => $aPaymentInfo,
				'billing_info'	 => $aBillingInfo,
				'shipping_info'	 => $aShippingInfo,
				'paid'			 => false
			));
			

			$sRedirectUrl = idealcheckout_getRootUrl() . 'idealcheckout/setup.php?order_id=' . urlencode($sOrderId) . '&order_code=' . urlencode($sOrderCode);

			wp_redirect($sRedirectUrl);
			exit;
		}

		function confirm_payment_form($aCart, $aShippingInfo)
		{
			return '';
		}

		function process_checkout_return($oOrder)
		{
			global $mp, $wpdb;

			$aDatabaseSettings = idealcheckout_getDatabaseSettings();

			$sOrderId = $_GET['order_id'];
			$sOrderCode = $_GET['order_code'];
			
			$oOrder	= new MP_Order($sOrderId);
			
			
			if($oOrder && !empty($sOrderId) && !empty($sOrderCode))
			{
				$sql = "SELECT * FROM `" . $aDatabaseSettings['table'] . "` WHERE (`order_id` = '" . idealcheckout_escapeSql($_GET['order_id']) . "') AND (`order_code` = '" . idealcheckout_escapeSql($_GET['order_code']) . "') LIMIT 1;";
				$aRecord = idealcheckout_database_getRecord($sql);

				if($aRecord && $aRecord['transaction_status'])
				{
					$aOrderParams = unserialize($aRecord['order_params']);

					if(isset($aOrderParams['last_status']) && (strcasecmp($aRecord['transaction_status'], $aOrderParams['last_status']) === 0))
					{
						if(in_array($aRecord['transaction_status'], array('SUCCESS')))
						{
							
							wp_redirect($oOrder->tracking_url(false));
							// return '<p>Uw betaling is ontvangen</p>';
						}
						elseif(in_array($aRecord['transaction_status'], array('PENDING')))
						{
							
							wp_redirect($oOrder->tracking_url(false));
							// return '<p>Uw betaling wordt verwerkt</p>';
						}
						else
						{
							// return '<p>Uw betaling is geannuleerd</p>';

							$this->_restoreCart($aRecord);

							$sRedirectUrl = mp_checkout_step_url('checkout');
							$sRedirectUrl .= ((strpos($sRedirectUrl, '?')) ? '&' : '?') . 'payment_method=maestro&payment_status=cancelled';

							wp_redirect($sRedirectUrl);
							exit;
						}

						return;
					}
					else
					{
						$aOrderParams['last_status'] = $aRecord['transaction_status'];
						$sql = "UPDATE `" . $aDatabaseSettings['table'] . "` SET `order_params` = '" . idealcheckout_escapeSql(serialize($aOrderParams)) . "' WHERE (`id` = '" . $aRecord['id'] . "') LIMIT 1;";
						idealcheckout_database_query($sql);
					}

/*
					$payment_info = $order->mp_payment_info;
					$payment_info['transaction_id'] = $aRecord['transaction_id'];
					$payment_info['status'][time()] = $aRecord['transaction_status'];
					$payment_info['method'] = 'idealcheckoutmaestro';

					update_post_meta($order->ID, 'mp_payment_info', $payment_info);
*/

					if(in_array($aRecord['transaction_status'], array('SUCCESS')))
					{
						$oOrder->log_ipn_status($aRecord['transaction_status']);
						$oOrder->change_status('paid', true);
				
						// return '<p>Uw betaling is ontvangen.</p>';
					}
					elseif(in_array($aRecord['transaction_status'], array('PENDING')))
					{
						$oOrder->log_ipn_status($aRecord['transaction_status']);
						$oOrder->change_status('paid', true);
						
						// return '<p>Uw betaling wordt verwerkt.</p>';
					}
					else
					{
						// Do nothing
					}
					
					wp_redirect($oOrder->tracking_url(false));
					exit;
				}
			}

			die('Invalid return');
		}

		function order_confirmation_email($sMessage, $oOrder)
		{
			return $sMessage;
		}

		function order_confirmation_msg($sContent, $oOrder)
		{
			global $mp, $wpdb;

			$aDatabaseSettings = idealcheckout_getDatabaseSettings();

			if($oOrder && !empty($_GET['order_id']) && !empty($_GET['order_code']))
			{
				$sql = "SELECT * FROM `" . $aDatabaseSettings['table'] . "` WHERE (`order_id` = '" . idealcheckout_escapeSql($_GET['order_id']) . "') AND (`order_code` = '" . idealcheckout_escapeSql($_GET['order_code']) . "') LIMIT 1;";
				$aRecord = idealcheckout_database_getRecord($sql);

				if($aRecord && $aRecord['transaction_status'])
				{
					if(in_array($aRecord['transaction_status'], array('SUCCESS')))
					{
						$sContent = '<p>Uw betaling is ontvangen.</p>' . $sContent;
					}
					elseif(in_array($aRecord['transaction_status'], array('PENDING')))
					{
						$sContent = '<p>Uw betaling wordt verwerkt.</p>' . $sContent;
					}
					else
					{
						$sContent = '<p>Uw betaling is geannuleerd.</p>' . $sContent;
					}
				}
			}

			return $sContent;
		}
	
		function gateway_settings_box($settings)
		{
			global $mp;

			$aGatewaySettings = idealcheckout_getGatewaySettings(false, 'maestro');

			$sHtml = '
	<div class="postbox">
    	<h3 class="handle"><span>iDEAL Checkout - Maestro</span></h3>
		<div class="inside">

<p>Via deze plugin kunt u Maestro betalingen ontvangen in uw webshop via diverse Payment Service Providers.</p>
<p>Deze plugin is momenteel geconfigureerd om Maestro transacties te verwerken via <b>' . htmlspecialchars($aGatewaySettings['GATEWAY_NAME']) . '</b>.<br>Meer informatie over deze Payment Service Provider vind u op <a href="' . htmlspecialchars($aGatewaySettings['GATEWAY_WEBSITE']) . '" target="_blank">' . htmlspecialchars($aGatewaySettings['GATEWAY_WEBSITE']) . '</a></p>';

			if($aGatewaySettings['GATEWAY_VALIDATION'])
			{
				$sHtml .= '
<p>&nbsp;</p>
<h2>Transacties Controleren</h2>
<p>Controleer de status van alle openstaande transacties bij uw Payment Service Provider.</p>
<p><input type="button" value="Controleer openstaande transacties." onclick="javascript: window.open(\'' . idealcheckout_getRootUrl(1) . 'idealcheckout/validate.php?gateway=maestro\', \'popup\', \'directories=no,height=550,location=no,menubar=no,resizable=yes,scrollbars=yes,status=no,toolbar=no,width=750\');"></p>';
			}

			$sHtml .= '
<p>&nbsp;</p>
<h2>Over deze plugin</h2>
<p>Deze Maestro plugin is ontwikkeld door <a href="https://www.ideal-checkout.nl" target="_blank">iDEAL Checkout</a> en is GRATIS te downloaden via <a href="http://www.ideal-checkout.nl" target="_blank">http://www.ideal-checkout.nl</a>.<br><br>- Voor vragen en support, kijk op <a href="http://www.ideal-checkout.nl" target="_blank">http://www.ideal-checkout.nl</a> of neem contact op met <a href="mailto:info@ideal-checkout.nl">info@ideal-checkout.nl</a>.<br>- Feedback en donaties worden zeer op prijs gesteld.<br>- Het gebruik van onze plugins/scripts is geheel op eigen risico.</p>

		</div>
	</div>';

			echo $sHtml;
		}
  
		function process_gateway_settings($settings)
		{
			return $settings;
		}

		function process_ipn_return()
		{
		}


		function _restoreCart($aRecord)
		{
			global $mp, $blog_id;

			$current_blog_id = (is_multisite()) ? $blog_id : 1;

			if(!empty($aRecord['order_params']))
			{
				$aOrderParams = unserialize($aRecord['order_params']);

				if(is_array($aOrderParams['cart']) && sizeof($aOrderParams['cart']))
				{
					$aCart = array();

					foreach($aOrderParams['cart'] as $a)
					{
						if($a['product_id'])
						{
							// $aCart[$a['product_id']][$a['variant_code']] = $a['quantity'];
							$aCart[$a['product_id']][] = $a['quantity'];
						}
					}

					$mp->set_cart_cookie($aCart);
				}
			}
		}
	}

	mp_register_gateway_plugin('MP_Gateway_Idealcheckoutmaestro', 'idealcheckoutmaestro', 'iDEAL Checkout - Maestro');

?>